;; $Id$
;;
;; Based on:		dbl1usen.dsl
;; Original Revision:	1.20
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://nwalsh.com/docbook/dsssl/
;;

;; ----------------------------- Localization -----------------------------

;; If you create a new version of this file, please send it to
;; Norman Walsh, ndw@nwalsh.com

;; The generated text for cross references to elements.  See dblink.dsl
;; for a discussion of how substitution is performed on the %x
;; keywords.
;;

(define (jpja-appendix-xref-string gi-or-name)
  (if %chapter-autolabel%
      "&Appendix; %n"
      "the &appendix; called %t"))

(define (jpja-article-xref-string gi-or-name)
  (string-append %gentext-jpja-start-quote%
		 "%t"
		 %gentext-jpja-end-quote%))

(define (jpja-bibliography-xref-string gi-or-name)
  "%t")

(define (jpja-book-xref-string gi-or-name)
  "%t")

(define (jpja-chapter-xref-string gi-or-name)
  (if %chapter-autolabel%
      "&Chapter; %n"
      "the &chapter; called %t"))

(define (jpja-equation-xref-string gi-or-name)
  "&Equation; %n")

(define (jpja-example-xref-string gi-or-name)
  "&Example; %n")

(define (jpja-figure-xref-string gi-or-name)
  "&Figure; %n")

(define (jpja-listitem-xref-string gi-or-name)
  "%n")

(define (jpja-part-xref-string gi-or-name)
  "&Part; %n")

(define (jpja-preface-xref-string gi-or-name)
  "%t")

(define (jpja-procedure-xref-string gi-or-name)
  "&Procedure; %n, %t")

(define (jpja-section-xref-string gi-or-name)
  (if %section-autolabel% 
      "&Section; %n" 
      "%tפ &section; "))

(define (jpja-sect1-xref-string gi-or-name)
  (jpja-section-xref-string gi-or-name))

(define (jpja-sect2-xref-string gi-or-name)
  (jpja-section-xref-string gi-or-name))

(define (jpja-sect3-xref-string gi-or-name)
  (jpja-section-xref-string gi-or-name))

(define (jpja-sect4-xref-string gi-or-name)
  (jpja-section-xref-string gi-or-name))

(define (jpja-sect5-xref-string gi-or-name)
  (jpja-section-xref-string gi-or-name))

(define (jpja-sidebar-xref-string gi-or-name)
  "the &sidebar; %t")

(define (jpja-step-xref-string gi-or-name)
  "&step; %n")

(define (jpja-table-xref-string gi-or-name)
  "&Table; %n")

(define (jpja-default-xref-string gi-or-name)
  (let* ((giname (if (string? gi-or-name) gi-or-name (gi gi-or-name)))
	 (msg    (string-append "[&xrefto; "
				(if giname giname "&nonexistantelement;")
				" &unsupported;]"))
	 (err    (node-list-error msg (current-node))))
    msg))

(define (gentext-jpja-xref-strings gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
      ((equal? name (normalize "appendix")) (jpja-appendix-xref-string gind))
      ((equal? name (normalize "article"))  (jpja-article-xref-string gind))
      ((equal? name (normalize "bibliography")) (jpja-bibliography-xref-string gind))
      ((equal? name (normalize "book"))     (jpja-book-xref-string gind))
      ((equal? name (normalize "chapter"))  (jpja-chapter-xref-string gind))
      ((equal? name (normalize "equation")) (jpja-equation-xref-string gind))
      ((equal? name (normalize "example"))  (jpja-example-xref-string gind))
      ((equal? name (normalize "figure"))   (jpja-figure-xref-string gind))
      ((equal? name (normalize "listitem")) (jpja-listitem-xref-string gind))
      ((equal? name (normalize "part"))     (jpja-part-xref-string gind))
      ((equal? name (normalize "preface"))  (jpja-preface-xref-string gind))
      ((equal? name (normalize "procedure")) (jpja-procedure-xref-string gind))
      ((equal? name (normalize "sect1"))    (jpja-sect1-xref-string gind))
      ((equal? name (normalize "sect2"))    (jpja-sect2-xref-string gind))
      ((equal? name (normalize "sect3"))    (jpja-sect3-xref-string gind))
      ((equal? name (normalize "sect4"))    (jpja-sect4-xref-string gind))
      ((equal? name (normalize "sect5"))    (jpja-sect5-xref-string gind))
      ((equal? name (normalize "sidebar"))  (jpja-sidebar-xref-string gind))
      ((equal? name (normalize "step"))     (jpja-step-xref-string gind))
      ((equal? name (normalize "table"))    (jpja-table-xref-string gind))
      (else (jpja-default-xref-string gind)))))

(define (jpja-auto-xref-indirect-connector before) 
  ;; In English, the (cond) is unnecessary since the word is always the
  ;; same, but in other languages, that's not the case.  I've set this
  ;; one up with the (cond) so it stands as an example.
  (cond 
   ((equal? (gi before) (normalize "book"))
    (literal " &in; "))
   ((equal? (gi before) (normalize "chapter"))
    (literal " &in; "))
   ((equal? (gi before) (normalize "sect1"))
    (literal " &in; "))
   (else
    (literal " &in; "))))

;; Should the TOC come first or last?
;;
(define %generate-jpja-toc-in-front% #t)

;; gentext-element-name returns the generated text that should be 
;; used to make reference to the selected element.
;;
(define jpja-abstract-name	"&Abstract;")
(define jpja-appendix-name	"&Appendix;")
(define jpja-article-name	"&Article;")
(define jpja-bibliography-name	"&Bibliography;")
(define jpja-book-name		"&Book;")
(define jpja-calloutlist-name	"")
(define jpja-caution-name	"&Caution;")
(define jpja-chapter-name	"&Chapter;")
(define jpja-copyright-name	"&Copyright;")
(define jpja-dedication-name	"&Dedication;")
(define jpja-edition-name	"&Edition;")
(define jpja-equation-name	"&Equation;")
(define jpja-example-name	"&Example;")
(define jpja-figure-name	"&Figure;")
(define jpja-glossary-name	"&Glossary;")
(define jpja-glosssee-name	"&GlossSee;")
(define jpja-glossseealso-name	"&GlossSeeAlso;")
(define jpja-important-name	"&Important;")
(define jpja-index-name		"&Index;")
(define jpja-setindex-name	"&SetIndex;")
(define jpja-isbn-name		"&ISBN;")
(define jpja-legalnotice-name	"&LegalNotice;")
(define jpja-msgaud-name	"&MsgAud;")
(define jpja-msglevel-name	"&MsgLevel;")
(define jpja-msgorig-name	"&MsgOrig;")
(define jpja-note-name		"&Note;")
(define jpja-part-name		"&Part;")
(define jpja-preface-name	"&Preface;")
(define jpja-procedure-name	"&Procedure;")
(define jpja-pubdate-name	"&Published;")
(define jpja-reference-name	"&Reference;")
(define jpja-refname-name	"&RefName;")
(define jpja-revhistory-name	"&RevHistory;")
(define jpja-revision-name	"&Revision;")
(define jpja-sect1-name		"&Section;")
(define jpja-sect2-name		"&Section;")
(define jpja-sect3-name		"&Section;")
(define jpja-sect4-name		"&Section;")
(define jpja-sect5-name		"&Section;")
(define jpja-simplesect-name	"&Section;")
(define jpja-seeie-name		"&See;")
(define jpja-seealsoie-name	"&Seealso;")
(define jpja-set-name		"&Set;")
(define jpja-sidebar-name	"&Sidebar;")
(define jpja-step-name		"&step;")
(define jpja-table-name		"&Table;")
(define jpja-tip-name		"&Tip;")
(define jpja-toc-name		"&TableofContents;")
(define jpja-warning-name	"&Warning;")

(define (gentext-jpja-element-name gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "abstract"))	jpja-abstract-name)
     ((equal? name (normalize "appendix"))	jpja-appendix-name)
     ((equal? name (normalize "article"))	jpja-article-name)
     ((equal? name (normalize "bibliography"))	jpja-bibliography-name)
     ((equal? name (normalize "book"))		jpja-book-name)
     ((equal? name (normalize "calloutlist"))	jpja-calloutlist-name)
     ((equal? name (normalize "caution"))	jpja-caution-name)
     ((equal? name (normalize "chapter"))	jpja-chapter-name)
     ((equal? name (normalize "copyright"))	jpja-copyright-name)
     ((equal? name (normalize "dedication"))	jpja-dedication-name)
     ((equal? name (normalize "edition"))	jpja-edition-name)
     ((equal? name (normalize "equation"))	jpja-equation-name)
     ((equal? name (normalize "example"))	jpja-example-name)
     ((equal? name (normalize "figure"))	jpja-figure-name)
     ((equal? name (normalize "glossary"))	jpja-glossary-name)
     ((equal? name (normalize "glosssee"))	jpja-glosssee-name)
     ((equal? name (normalize "glossseealso"))	jpja-glossseealso-name)
     ((equal? name (normalize "important"))	jpja-important-name)
     ((equal? name (normalize "index"))		jpja-index-name)
     ((equal? name (normalize "setindex"))	jpja-setindex-name)
     ((equal? name (normalize "isbn"))		jpja-isbn-name)
     ((equal? name (normalize "legalnotice"))	jpja-legalnotice-name)
     ((equal? name (normalize "msgaud"))	jpja-msgaud-name)
     ((equal? name (normalize "msglevel"))	jpja-msglevel-name)
     ((equal? name (normalize "msgorig"))	jpja-msgorig-name)
     ((equal? name (normalize "note"))		jpja-note-name)
     ((equal? name (normalize "part"))		jpja-part-name)
     ((equal? name (normalize "preface"))	jpja-preface-name)
     ((equal? name (normalize "procedure"))	jpja-procedure-name)
     ((equal? name (normalize "pubdate"))	jpja-pubdate-name)
     ((equal? name (normalize "reference"))	jpja-reference-name)
     ((equal? name (normalize "refname"))	jpja-refname-name)
     ((equal? name (normalize "revhistory"))	jpja-revhistory-name)
     ((equal? name (normalize "revision"))	jpja-revision-name)
     ((equal? name (normalize "sect1"))		jpja-sect1-name)
     ((equal? name (normalize "sect2"))		jpja-sect2-name)
     ((equal? name (normalize "sect3"))		jpja-sect3-name)
     ((equal? name (normalize "sect4"))		jpja-sect4-name)
     ((equal? name (normalize "sect5"))		jpja-sect5-name)
     ((equal? name (normalize "simplesect"))    jpja-simplesect-name)
     ((equal? name (normalize "seeie"))		jpja-seeie-name)
     ((equal? name (normalize "seealsoie"))	jpja-seealsoie-name)
     ((equal? name (normalize "set"))		jpja-set-name)
     ((equal? name (normalize "sidebar"))	jpja-sidebar-name)
     ((equal? name (normalize "step"))		jpja-step-name)
     ((equal? name (normalize "table"))		jpja-table-name)
     ((equal? name (normalize "tip"))		jpja-tip-name)
     ((equal? name (normalize "toc"))		jpja-toc-name)
     ((equal? name (normalize "warning"))	jpja-warning-name)
     (else (let* ((msg (string-append "gentext-jpja-element-name: &unexpectedelementname;: " name))
		  (err (node-list-error msg (current-node))))
	     msg)))))

;; gentext-element-name-space returns gentext-element-name with a 
;; trailing space, if gentext-element-name isn't "".
;;
(define (gentext-jpja-element-name-space giname)
  (string-with-space (gentext-element-name giname)))

;; gentext-intra-label-sep returns the seperator to be inserted
;; between multiple occurances of a label (or parts of a label)
;; for the specified element.  Most of these are for enumerated
;; labels like "Figure 2-4", but this function is used elsewhere
;; (e.g. REFNAME) with a little abuse.
;;

(define jpja-equation-intra-label-sep "-")
(define jpja-example-intra-label-sep "-")
(define jpja-figure-intra-label-sep "-")
(define jpja-procedure-intra-label-sep ".")
(define jpja-refentry-intra-label-sep ".")
(define jpja-reference-intra-label-sep ".")
(define jpja-refname-intra-label-sep ", ")
(define jpja-refsect1-intra-label-sep ".")
(define jpja-refsect2-intra-label-sep ".")
(define jpja-refsect3-intra-label-sep ".")
(define jpja-sect1-intra-label-sep ".")
(define jpja-sect2-intra-label-sep ".")
(define jpja-sect3-intra-label-sep ".")
(define jpja-sect4-intra-label-sep ".")
(define jpja-sect5-intra-label-sep ".")
(define jpja-step-intra-label-sep ".")
(define jpja-table-intra-label-sep "-")
(define jpja-_pagenumber-intra-label-sep "-")
(define jpja-default-intra-label-sep "")

(define (gentext-jpja-intra-label-sep gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "equation"))	jpja-equation-intra-label-sep)
     ((equal? name (normalize "example"))	jpja-example-intra-label-sep)
     ((equal? name (normalize "figure"))	jpja-figure-intra-label-sep)
     ((equal? name (normalize "procedure"))	jpja-procedure-intra-label-sep)
     ((equal? name (normalize "refentry"))	jpja-refentry-intra-label-sep)
     ((equal? name (normalize "reference"))	jpja-reference-intra-label-sep)
     ((equal? name (normalize "refname"))	jpja-refname-intra-label-sep)
     ((equal? name (normalize "refsect1"))	jpja-refsect1-intra-label-sep)
     ((equal? name (normalize "refsect2"))	jpja-refsect2-intra-label-sep)
     ((equal? name (normalize "refsect3"))	jpja-refsect3-intra-label-sep)
     ((equal? name (normalize "sect1"))		jpja-sect1-intra-label-sep)
     ((equal? name (normalize "sect2"))		jpja-sect2-intra-label-sep)
     ((equal? name (normalize "sect3"))		jpja-sect3-intra-label-sep)
     ((equal? name (normalize "sect4"))		jpja-sect4-intra-label-sep)
     ((equal? name (normalize "sect5"))		jpja-sect5-intra-label-sep)
     ((equal? name (normalize "step"))		jpja-step-intra-label-sep)
     ((equal? name (normalize "table"))		jpja-table-intra-label-sep)
     ((equal? name (normalize "_pagenumber"))	jpja-_pagenumber-intra-label-sep)
     (else jpja-default-intra-label-sep))))

;; gentext-label-title-sep returns the seperator to be inserted
;; between a label and the text following the label for the
;; specified element.  Most of these are for use between
;; enumerated labels and titles like "1. Chapter One Title", but
;; this function is used elsewhere (e.g. NOTE) with a little
;; abuse.
;;

(define jpja-abstract-label-title-sep ": ")
(define jpja-appendix-label-title-sep ". ")
(define jpja-caution-label-title-sep "")
(define jpja-chapter-label-title-sep ". ")
(define jpja-equation-label-title-sep ". ")
(define jpja-example-label-title-sep ". ")
(define jpja-figure-label-title-sep ". ")
(define jpja-footnote-label-title-sep ". ")
(define jpja-glosssee-label-title-sep ": ")
(define jpja-glossseealso-label-title-sep ": ")
(define jpja-important-label-title-sep ": ")
(define jpja-note-label-title-sep ": ")
(define jpja-orderedlist-label-title-sep ". ")
(define jpja-part-label-title-sep ". ")
(define jpja-procedure-label-title-sep ". ")
(define jpja-prefix-label-title-sep ". ")
(define jpja-refentry-label-title-sep "")
(define jpja-reference-label-title-sep ". ")
(define jpja-refsect1-label-title-sep ". ")
(define jpja-refsect2-label-title-sep ". ")
(define jpja-refsect3-label-title-sep ". ")
(define jpja-sect1-label-title-sep ". ")
(define jpja-sect2-label-title-sep ". ")
(define jpja-sect3-label-title-sep ". ")
(define jpja-sect4-label-title-sep ". ")
(define jpja-sect5-label-title-sep ". ")
(define jpja-seeie-label-title-sep " ")
(define jpja-seealsoie-label-title-sep " ")
(define jpja-step-label-title-sep ". ")
(define jpja-table-label-title-sep ". ")
(define jpja-tip-label-title-sep ": ")
(define jpja-warning-label-title-sep "")
(define jpja-default-label-title-sep "")

(define (gentext-jpja-label-title-sep gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "abstract")) jpja-abstract-label-title-sep)
     ((equal? name (normalize "appendix")) jpja-appendix-label-title-sep)
     ((equal? name (normalize "caution")) jpja-caution-label-title-sep)
     ((equal? name (normalize "chapter")) jpja-chapter-label-title-sep)
     ((equal? name (normalize "equation")) jpja-equation-label-title-sep)
     ((equal? name (normalize "example")) jpja-example-label-title-sep)
     ((equal? name (normalize "figure")) jpja-figure-label-title-sep)
     ((equal? name (normalize "footnote")) jpja-footnote-label-title-sep)
     ((equal? name (normalize "glosssee")) jpja-glosssee-label-title-sep)
     ((equal? name (normalize "glossseealso")) jpja-glossseealso-label-title-sep)
     ((equal? name (normalize "important")) jpja-important-label-title-sep)
     ((equal? name (normalize "note")) jpja-note-label-title-sep)
     ((equal? name (normalize "orderedlist")) jpja-orderedlist-label-title-sep)
     ((equal? name (normalize "part")) jpja-part-label-title-sep)
     ((equal? name (normalize "procedure")) jpja-procedure-label-title-sep)
     ((equal? name (normalize "prefix")) jpja-prefix-label-title-sep)
     ((equal? name (normalize "refentry")) jpja-refentry-label-title-sep)
     ((equal? name (normalize "reference")) jpja-reference-label-title-sep)
     ((equal? name (normalize "refsect1")) jpja-refsect1-label-title-sep)
     ((equal? name (normalize "refsect2")) jpja-refsect2-label-title-sep)
     ((equal? name (normalize "refsect3")) jpja-refsect3-label-title-sep)
     ((equal? name (normalize "sect1")) jpja-sect1-label-title-sep)
     ((equal? name (normalize "sect2")) jpja-sect2-label-title-sep)
     ((equal? name (normalize "sect3")) jpja-sect3-label-title-sep)
     ((equal? name (normalize "sect4")) jpja-sect4-label-title-sep)
     ((equal? name (normalize "sect5")) jpja-sect5-label-title-sep)
     ((equal? name (normalize "seeie")) jpja-seeie-label-title-sep)
     ((equal? name (normalize "seealsoie")) jpja-seealsoie-label-title-sep)
     ((equal? name (normalize "step")) jpja-step-label-title-sep)
     ((equal? name (normalize "table")) jpja-table-label-title-sep)
     ((equal? name (normalize "tip")) jpja-tip-label-title-sep)
     ((equal? name (normalize "warning")) jpja-warning-label-title-sep)
     (else jpja-default-label-title-sep))))

(define (jpja-set-label-number-format gind) "1")
(define (jpja-book-label-number-format gind) "1")
(define (jpja-prefix-label-number-format gind) "1")
(define (jpja-part-label-number-format gind) "I")
(define (jpja-chapter-label-number-format gind) "1")
(define (jpja-appendix-label-number-format gind) "A")
(define (jpja-reference-label-number-format gind) "I")
(define (jpja-example-label-number-format gind) "1")
(define (jpja-figure-label-number-format gind) "1")
(define (jpja-table-label-number-format gind) "1")
(define (jpja-procedure-label-number-format gind) "1")
(define (jpja-step-label-number-format gind) "1")
(define (jpja-refsect1-label-number-format gind) "1")
(define (jpja-refsect2-label-number-format gind) "1")
(define (jpja-refsect3-label-number-format gind) "1")
(define (jpja-sect1-label-number-format gind) "1")
(define (jpja-sect2-label-number-format gind) "1")
(define (jpja-sect3-label-number-format gind) "1")
(define (jpja-sect4-label-number-format gind) "1")
(define (jpja-sect5-label-number-format gind) "1")
(define (jpja-default-label-number-format gind) "1")

(define (jpja-label-number-format gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond
     ((equal? name (normalize "set")) (jpja-set-label-number-format gind))
     ((equal? name (normalize "book")) (jpja-book-label-number-format gind))
     ((equal? name (normalize "prefix")) (jpja-prefix-label-number-format gind))
     ((equal? name (normalize "part")) (jpja-part-label-number-format gind))
     ((equal? name (normalize "chapter")) (jpja-chapter-label-number-format gind))
     ((equal? name (normalize "appendix")) (jpja-appendix-label-number-format gind))
     ((equal? name (normalize "reference")) (jpja-reference-label-number-format gind))
     ((equal? name (normalize "example")) (jpja-example-label-number-format gind))
     ((equal? name (normalize "figure")) (jpja-figure-label-number-format gind))
     ((equal? name (normalize "table")) (jpja-table-label-number-format gind))
     ((equal? name (normalize "procedure")) (jpja-procedure-label-number-format gind))
     ((equal? name (normalize "step")) (jpja-step-label-number-format gind))
     ((equal? name (normalize "refsect1")) (jpja-refsect1-label-number-format gind))
     ((equal? name (normalize "refsect2")) (jpja-refsect2-label-number-format gind))
     ((equal? name (normalize "refsect3")) (jpja-refsect3-label-number-format gind))
     ((equal? name (normalize "sect1")) (jpja-sect1-label-number-format gind))
     ((equal? name (normalize "sect2")) (jpja-sect2-label-number-format gind))
     ((equal? name (normalize "sect3")) (jpja-sect3-label-number-format gind))
     ((equal? name (normalize "sect4")) (jpja-sect4-label-number-format gind))
     ((equal? name (normalize "sect5")) (jpja-sect5-label-number-format gind))
     (else (jpja-default-label-number-format gind)))))

(define ($lot-title-jpja$ gind)
  (let* ((giname (if (string? gind) gind (gi gind)))
	 (name   (normalize giname)))
    (cond ((equal? name (normalize "table"))    "&ListofTables;")
	  ((equal? name (normalize "example"))  "&ListofExamples;")
	  ((equal? name (normalize "figure"))   "&ListofFigures;")
	  ((equal? name (normalize "equation")) "&ListofEquations;")
	  (else (let* ((msg (string-append "&ListofUnknown;: " name))
		       (err (node-list-error msg (current-node))))
		  msg)))))

(define %gentext-jpja-start-quote% (dingbat "ldquo"))

(define %gentext-jpja-end-quote% (dingbat "rdquo"))

(define %gentext-jpja-by% "&by;") ;; e.g. Copyright 1997 "by" A. Nonymous
                           ;; Authored "by" Jane Doe

(define %gentext-jpja-edited-by% "&Editedby;")
                           ;; "Edited by" Jane Doe

(define %gentext-jpja-page% "")

(define %gentext-jpja-and% "&and;")

(define %gentext-jpja-bibl-pages% "&Pgs;")

(define %gentext-jpja-endnotes% "&Notes;")

(define %gentext-jpja-table-endnotes% "&TableNotes;:")

(define %gentext-jpja-index-see% "&See;")

(define %gentext-jpja-index-seealso% "&SeeAlso;")

